<template>
  <v-container>
    <page-title>
      Reporte de indicadores de desempeño para un especialista
    </page-title>
    <div class="labelStyle">
      Seleccione un especialista para generar su reporte correspondiente:
    </div>
    <page-content class="mt-0">
      <page-content-list-user>
        <template #buttons>
          <data-button class="mt-1" button-name="Generar Reporte" icon="mdi-book-plus-multiple" @clicked="showReport"/>
        </template>
        <template #table>
          <search-table
            table-title="Especialistas"
            :headers="headers"
            :full-name="true"
            :items="specialists"
            :page="page"
            :items-per-page="pageSize"
            :loading="loading"
            :single-select="true"
            :show-select="true"
            search-text="Busca un especialista"
            v-on:selectRow="rowSelected"
            @eventPagination="paginator"
          >
            <div class="text-center">
              <v-pagination
                v-model="page"
                :length="Math.ceil(totalSpecialists/pageSize)"
                :total-visible="7"
              ></v-pagination>
            </div>
          </search-table>
        </template>
      </page-content-list-user>
    </page-content>
  </v-container>
</template>

<script>
import { mapActions, mapState } from 'vuex';
import PageTitle from '~/components/PageTitle';
import PageContent from '~/components/PageContent';
import PageContentListUser from '~/components/PageContentListUser';
import SearchTable from '~/components/supervisor/SearchTable';

export default {
  name: 'SpecialistTable',
  components: {
    SearchTable,
    PageTitle,
    PageContent,
    PageContentListUser,
  },
  data() {
    return {
      headers: [
        { text: 'Nombres Completos', align: 'start', value: 'full_name', filterable: true },
        { text: 'Tipo de Documento', align: 'center', value: 'user.typeDocument' },
        { text: 'N° de Documento', value: 'user.document' },
        { text: 'Correo', value: 'email' },
        { text: 'N° de Celular', value: 'phoneNumber' },
        { text: 'Estado', value: 'isBlocked' },
      ],
      pageSize: 10,
      page: 1,
      rows: [],

    };
  },
  computed: {
    ...mapState({
      // Get all the specialists from state.
      specialists: state => state.specialists.specialists,
      totalSpecialists: state => state.specialists.totalSpecialists,
      loading: state => state.specialists.loading,
    }),
  },
  mounted() {
    this.getAllSpecialists(parseInt(this.$route.query.p));
  },
  methods: {
    ...mapActions({
      getSpecialists: 'specialists/getSpecialists',
    }),
    handleClick() {
      this.$router.push('/especialistas/nuevo-especialista');
    },
    async getAllSpecialists(page = 1) {
      if (isNaN(page)) {
        this.page = 1;
      } else {
        this.page = page;
      }
      let params;
      if (Object.entries(this.$route.query).length === 0) {
        params = { page: this.page - 1, pagesize: this.pageSize /* search: searchI */ };
      } else { // If enter by query params.
        params = { page: this.page - 1, pagesize: this.pageSize, search: this.$route.query.s };
      }
      await this.getSpecialists(params);
      this.setRows();
    },
    setRows() {
      this.rows = this.specialists;
    },
    rowSelected(item, row) {
    },
    showReport(item, row) {
      console.log('showReport');
      // this.$router.push(`/reportes-proveedor/especialista-específico/${item.uuid}`);
      this.$router.push('/reportes-proveedor/especialista-especifico');
    },
    async paginator(page) {
      await this.$router.push({ path: '/especialistas', query: { p: page } });

      // Update the table, with paginator.
      this.page = page;
      await this.getAllSpecialists(page);
    },

  },
};
</script>

<style scoped>
.labelStyle{
  padding-left: 20px;
  padding-top: 15px;
  font-family: "Montserrat", sans-serif;
  font-size: 17px;
  color: #505050;
}
</style>
